<template>
<div>
    <p>Requests</p>
    <div v-for="(request, key) in requests" v-bind:key="key">{{ request.message }}</div>
</div>
</template>

<script>

import { register } from 'register-service-worker';

export default {
  components: {
  },

  data() {
    return {
        // requests: this.$store.nearHostingRequests
    }
  },

  computed: {
    requests() {
      return this.$store.state.hostingRequests
    }
  },

  mounted () {


    this.$store.dispatch('getHostingRequests')

    // let self = this
    // io.socket.get('/hostingRequest?city=Warszawa', {jwt: io.sails.headers.jwt}, function (body, JWR) {
    //   if (JWR.error) { return console.log(JWR.error)} // check if thats token issue and do sth

    //   body.forEach(function (row) {
    //     self.requests.push(
    //       row.message
    //     )
    //   })
    // })
    // io.socket.on('hostingrequest', function (body) {
    //   self.requests.push(
    //     body.data.message
    //   )
    // })

    // axios.post('http://localhost:1337/hostingRequest', {
    //   city: 'Warszawa',
    //   country: 'Polska',
    //   status: 'pending',
    //   dateFrom: '123',
    //   dateTo: '123',
    //   _csrf: window.sailsCsrf
    // })
    //   .then(res => {
    //     console.log(res)
    //   })
    //   .catch(err => {
    //     console.log(err)
    //   })

    // console.log(92345)


    // axios.get('http://localhost:1337/user?where={"emailAddress":{"contains":"admin"}}')
    //     .then(res => {console.log(res)})
  },

  methods: {

    requestPermission() {

        let self = this;
                    console.log('11111111111111111111111111111')
          return new Promise(function(resolve, reject) {
            const permissionResult = Notification.requestPermission(function(result) {
              // Handling deprecated version with callback.
              resolve(result);
            });

            if (permissionResult) {
              permissionResult.then(resolve, reject);
            }
          })
          .then(function(permissionResult) {
            if (permissionResult !== 'granted') {
              throw new Error('Permission not granted.');
            }

            self.subscribeUserToPush()
          });
        },


    subscribeUserToPush() {

                return navigator.serviceWorker.register(`${process.env.BASE_URL}lol.js`)
                    .then(function (reg) {
                        console.log('SV2 registe3red')

                        var subscribeOptions = {
                          userVisibleOnly: true,
                          applicationServerKey: btoa(
                            'BEl62iUYgUivxIkv69yViEuiBIa-Ib9-SkvMeAtA3LFgDzkrxZJjSgSnfckjBJuBkr3qBUYIHBQFLXYp5Nksh8U'
                          )
                        };

                        return reg.pushManager.subscribe(subscribeOptions);

                    })
                    .then(function(pushSubscription) {
                        console.log('PushSubscription: ', JSON.stringify(pushSubscription));
                        return pushSubscription;
                    });


              // return register(`${process.env.BASE_URL}service-worker.js`)
              // .then(function(registration) {
              //   console.log('sucess loli')
              //   // var subscribeOptions = {
              //   //   userVisibleOnly: true,
              //   //   applicationServerKey: btoa(
              //   //     'BEl62iUYgUivxIkv69yViEuiBIa-Ib9-SkvMeAtA3LFgDzkrxZJjSgSnfckjBJuBkr3qBUYIHBQFLXYp5Nksh8U'
              //   //   )
              //   // };

              //   // return registration.pushManager.subscribe(subscribeOptions);
              // }, function(error) {console.log(error)})
              // // .then(function(pushSubscription) {
              // //   console.log('PushSubscription: ', JSON.stringify(pushSubscription));
              // //   return pushSubscription;
              // // });
        },  
  }
}
</script>
